package net.lecnam.GLG101;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvFileSource;
import org.junit.jupiter.params.provider.CsvSource;

class CalculatorTest {

	Calculator calc = new Calculator();

	@Test
	void testAdd() {
		int actual = calc.add(3, 4);
		int expected = 7;
		assertEquals(expected, actual);
	}

	@Test
	void testAdd2() {
		int actual = calc.add(30, 40);
		int expected = 70;
		assertEquals(expected, actual);
	}

	@Test
	void testDiv() {
		int actual = calc.div(10, 2);
		int expected = 5;
		assertEquals(expected, actual);
	}

	@Test
	@Disabled
	void testDiv2() {
		int actual = calc.div(10, 0);
		int expected = 5;
		assertEquals(expected, actual);
	}

	@Test
	@Disabled
	void testProd() {
		int actual = calc.prod(7, 2);
		int expected = 14;
		assertEquals(expected, actual);
	}

	@Test
	@Disabled
	void testProd2() {
		int actual = calc.prod(1, 1);
		int expected = 1;
		assertEquals(expected, actual);
	}

	@Test
	@Disabled
	void testProd3() {
		int actual = calc.prod(1, 0);
		int expected = 0;
		assertEquals(expected, actual);
	}

	@Test
	@Disabled
	void testProd4() {
		int actual = calc.prod(0, 1);
		int expected = 0;
		assertEquals(expected, actual);
	}

	@Test
	@Disabled
	void testProd5() {
		int actual = calc.prod(0, 0);
		int expected = 0;
		assertEquals(expected, actual);
	}

	@ParameterizedTest
	@Disabled
	@CsvSource({"0, 1, 0", "1, 0, 0", "1, 1, 1"})
	void testProd(int x, int y, int expected) {
		int actual = calc.prod(x, y);
		assertEquals(expected, actual);
	}

	@ParameterizedTest
	@CsvFileSource(resources = "/testProd2.csv", numLinesToSkip = 1)
	void testProd2(int x, int y, int expected) {
		int actual = calc.prod(x, y);
		assertEquals(expected, actual);
	}

	@Test
	void testShortest() {
		String actual = calc.shortest("x", "yy", "zzz");
		String expected = "x";
		assertEquals(expected, actual);
	}

	@Test
	void testShortest2() {
		String actual = calc.shortest("xx", "yyy", "z");
		String expected = "z";
		assertEquals(expected, actual);
	}

	@Test
	void testShortest3() {
		String actual = calc.shortest("xxx", "yy", "z");
		String expected = "z";
		assertEquals(expected, actual);
	}

	@Test
	void testShortest4() {
		String actual = calc.shortest("xxx", "y", "zz");
		String expected = "y";
		assertEquals(expected, actual);
	}

	@ParameterizedTest
	@CsvSource({"x,yy,zzz", "xx,y,zzz", "xxx,yy,z"})
	void testShortestProperty(String x, String y, String z) {
		String actual = calc.shortest(x, y, z);
		assertTrue(
				actual.length() <= x.length() 
				&& actual.length() <= y.length()
				&& actual.length() <= z.length()
				&& (actual == x || actual == y || actual == z));
	}

}
